/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.checksum;

private import std.md5;
private import std.string;
private import std.stream;

bool checkMD5Sum(ubyte[] hash, void[] data)
{
	ubyte[16] hash2;
	
	std.md5.sum(hash2, data);
	
	return hash2 == hash ? true: false;
}

bool checkSum8(byte sum, void[] data)
{
	return sum8(data) == sum ? true: false;
}

bool checkSum16(ushort sum, void[] data)
{
	return sum16(data) == sum ? true: false;
}

bool checkSum32(uint sum, void[] data)
{
	return sum32(data) == sum ? true: false;
}

ubyte[] md5Sum(void[] data)
{
	ubyte[16] hash;
	std.md5.sum(hash, data);
	
	return hash.dup;
}

ubyte[] md5FileSum(char[] filepath)
{
//		auto MmFile 	mmap 		= new MmFile(filepath);
//		MmFileStream	stream		= new MmFileStream(mmap);
	File		stream		= new File(filepath);
	MD5_CTX 		context;
	int len;
	ubyte[0x1000] 	buffer;
	ubyte digest[16];
	
	context.start();
	
	while ((len = stream.readBlock(buffer.ptr, buffer.length)) != 0) {
		context.update(buffer[0 .. len]);
	}
	stream.close();
	
	context.finish(digest);
	
	return digest.dup;
}

ubyte sum8(void[] data)
{
	return cast(ubyte)(sum32(data) & 0xff);
}

ushort sum16(void[] data)
{
	return cast(ushort)(sum32(data) & 0xffff);
}

uint sum32(void[] data)
{
	if (data.length == 0) {
		return 0;
	}
	ubyte[] byteary = cast(ubyte[])data;
	uint sum = 0;
	
	
	foreach (ubyte b; byteary) {
		sum += b;
	}
	
	return sum;
}
