﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.net.winny.cluster;

// クラスタリンクワード相関性評価関数


private import std.utf;
private import pes.wstring;

uint clusterCorrelationPoint(
	char[][] my_word_8,
	char[][] node_word_8)
in {
	assert(my_word_8.length == 3);
	assert(node_word_8.length == 3);
}
body {
	int i, j;
	uint total_point; 	// 評価値(合計)
	uint word_point;		// ワードごとの評価値（長さ）
	
	wchar[][3] my_valid_word;
	wchar[][3] node_valid_word;
	
	wchar[][3] my_word;
	wchar[][3] node_word;
	
	my_word[0] 		= toUTF16(my_word_8[0]);
	my_word[1] 		= toUTF16(my_word_8[1]);
	my_word[2] 		= toUTF16(my_word_8[2]);
	node_word[0]	= toUTF16(node_word_8[0]);
	node_word[1]	= toUTF16(node_word_8[1]);
	node_word[2]	= toUTF16(node_word_8[2]);
	
	// キーワードの重複をなくす1
	my_valid_word[0] = my_word[0];
	if (findKeyword(my_word[1], my_valid_word[0]) == false) {
		my_valid_word[1] = my_word[1];
	}
	if (findKeyword(my_word[2], my_valid_word[0]) == false
		&& (my_valid_word[1].length == 0 || findKeyword(my_word[2], my_valid_word[1]) == false))
	{
		my_valid_word[2] = my_word[2];
	}
	
	// キーワードの重複をなくす2
	node_valid_word[0] = node_word[0];
	if (findKeyword(node_word[1], node_valid_word[0]) == false) {
		node_valid_word[1] = node_word[1];
	}
	if (findKeyword(node_word[2], node_valid_word[0]) == false
		&& (node_valid_word[1].length == 0 || findKeyword(node_word[2], node_valid_word[1]) == false))
	{
		node_valid_word[2] = node_word[2];
	}
	
	// 選択されたワード同士を比較し合い一致したワード長を評価値として計算する
	total_point = 0;
	for (i = 0; i < node_word.length; i++) {
		if (node_valid_word[i].length < 2) {
			continue;// 1文字以下の単語は無視
		}
		for (j = 0; j < my_word.length; j++) {
			if (my_valid_word[j].length < 2) {
				continue;// 1文字以下の単語は無視
			}
			if (node_valid_word[i].length < my_valid_word[j].length) {
				if (findKeyword(my_valid_word[j], node_valid_word[i]) != false) {
					// 含まれた！1
					word_point = node_valid_word[i].length;
				} else {
					continue; // 含まれることはない
				}
			} else if (findKeyword(node_valid_word[i], my_valid_word[j]) != false) {
				// 含まれた！2
				word_point = my_valid_word[j].length;
			}
			else {
				continue;	// 互いに含まれない
			}
			total_point += word_point;
		}
	}
	
	/* 100以下に丸める */
	return total_point > 100 ? 100: total_point;
}

