﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.system.delay;

// タスクディレイ


version(Win32) {
	import std.c.windows.windows;
}
version(linux) {
	import std.c.time;
	
	struct timespec {
        time_t	tv_sec;         /* 秒 		*/
        uint	tv_nsec;        /* ナノ秒 	*/
	}
	extern (C) {
		int nanosleep(timespec *req, timespec *rem);
	}
}

// ミリ秒とまる
void delayTask(uint msec)
{
	version(Win32) {
		Sleep(msec);
	}
	version(linux)
	{
		// 想像上の物
		
		timespec	spec;
		
		spec.tv_sec 	= msec / 1000;
		spec.tv_nsec 	= (msec % 1000) * 1000;
		
		nanosleep(&spec, null);
	}
}

